package Linked_List is

   type Length is range 0 .. 1_000;
   subtype Position is Length;
   subtype Extended_Index is Length;
   subtype Index is Extended_Index range 1 .. 1_000;
   No_Index : constant := 0;
   Pos_Zero : constant := 0;

   type Node is record
      Value : Integer;
      Next  : Extended_Index;
   end record;

   type Data is array (Index) of Node;

   type List is record
      Head : Extended_Index;
      Raw  : Data;
   end record;

   --# type List_Data is abstract;
   --# function Contains (LD : List_Data; V : Integer) return Boolean;

   --# function List_Length (L : List) return Length;
   --# function Nth (L : List; N : Position) return Extended_Index;
   --# function Content (L : List) return List_Data;
   --# function Content_First_N (L : List; N : Position) return List_Data;

   function Search (L : in List) return Position;
   --# return R =>
   --#   (R = List_Length (L) and not Contains (Content (L), 0)) or
   --#   (R < List_Length (L) and L.Raw(Nth (L, R)).Value = 0 and
   --#      not Contains (Content_First_N (L, R), 0));

end Linked_List;
