package body Queens is

   function Is_Consistent (B : Board; Pos : Index) return Boolean is
      Cons : Boolean;
   begin
      Cons := True;
      for J in Index range 1 .. Pos - 1 loop
         if not ((B(J) /= B(Pos))
                  and then (B(J) - B(Pos) /= Pos - J)
                  and then (B(Pos) - B(J) /= Pos - J)) then
            Cons := False;
            exit;
         end if;
         --# assert Cons = True and Pos = Pos% and
         --#        (for all K in Index range 1 .. J =>
         --#           (B(K) /= B(Pos) and
         --#            B(K) - B(Pos) /= Pos - K and
         --#            B(Pos) - B(K) /= Pos - K));
      end loop;
      return Cons;
   end Is_Consistent;

   procedure Search (B : out Board; N : in Size; Success : out Boolean) is
      Pos : Index          := 1;
      J   : Extended_Index := 1;
   begin
      Success := False;
      B       := (others => 1);

      loop
         --# assert not Success and B'First = 1 and B'Last = N and
         --#        Pos >= 1 and Pos <= N;

         while J <= N loop
            --# assert not Success and J <= N and B'First = 1 and B'Last = N and
            --#        Pos >= 1 and Pos <= N;

            B(Pos) := J;

            if Is_Consistent (B, Pos) then
               if Pos = N then
                  Success := True;
               else
                  Pos := Pos + 1;
                  J   := 1;
               end if;
               exit;
            end if;

            J := J + 1;
         end loop;

         exit when Success;

         --  backtrack if no solution found
         if J /= 1 then
            while Pos > 1 and then B(Pos) = N loop
               Pos := Pos - 1;
               --# assert not Success and Pos >= 1 and Pos < N;
            end loop;
         end if;

         --  no solution found, exit
         exit when J /= 1 and then B(Pos) = N;

         if J /= 1 then
            J := B(Pos) + 1;
         end if;
      end loop;
   end Search;

end Queens;
