package Queens is

   type Size_Base is range -999 .. 1_001;
   subtype Extended_Index is Size_Base range 1 .. 1_001;
   subtype Size is Size_Base range 1 .. 1_000;
   subtype Index is Size;
   type Board is array (Index range <>) of Index;

   --  Return whether the queen in column Pos conflicts with a queen in a
   --  previous column.
   function Is_Consistent (B : Board; Pos : Index) return Boolean;
   --# pre B'First = 1 and Pos <= B'Last;
   --# return (for all J in Index range 1 .. Pos - 1 =>
   --#           (B(J) /= B(Pos) and
   --#            B(J) - B(Pos) /= Pos - J and
   --#            B(Pos) - B(J) /= Pos - J));

   procedure Search (B : out Board; N : in Size; Success : out Boolean);
   --# derives B, success from N;
   --# pre  B'First = 1 and B'Last = N;
   --# post Success -> Is_Consistent (B, N);

end Queens;
